/*
 * Away.mod
 * Version 1.0
 * By Wcc
 * http://www.dawgtcl.com:81/
 * wcc@techmonkeys.org
 *
 * This module makes the bot go away on IRC.
 *
 * Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved.
 *
 */

#define MODULE_NAME "away"
#define MAKING_AWAY
#define AWAY_MAJORV 1
#define AWAY_MINORV 0
#include "src/mod/module.h"
#include <stdlib.h>
#undef global

static Function *global = NULL;

char *away_start();

static int away_expmem()
{
  return 0;
}

static void away_report(int idx, int details)
{
  if (details)
    dprintf(idx, "   Away.mod Version %d.%d by Wcc is loaded.\n", AWAY_MAJORV, AWAY_MINORV);
}

static void cmd_saway(struct userrec *u, int idx, char *par)
{
  if (!par[0]) {
    dprintf(DP_SERVER, "AWAY\n");
    dprintf(idx, "I am no longer marked as away.\n");
    putlog(LOG_CMDS, "*", "#%s# saway", dcc[idx].nick);
  }
  else {
    dprintf(DP_SERVER, "AWAY :%s\n", par);
    dprintf(idx, "I am now marked as away.\n");
    putlog(LOG_CMDS, "*", "#%s# saway %s", dcc[idx].nick, par);
  }
}

static cmd_t away_dcc[] =
{
  {"saway",     "n",    (Function) cmd_saway,       NULL},
  {NULL,        NULL,   NULL,                       NULL}
};

static char *away_close()
{
  module_undepend(MODULE_NAME);
  rem_builtins(H_dcc, away_dcc);
  return NULL;
}

static Function away_table[] =
{
  (Function) away_start,
  (Function) away_close,
  (Function) away_expmem,
  (Function) away_report,
};

char *away_start(Function *global_funcs)
{
  global = global_funcs;
  module_register(MODULE_NAME, away_table, AWAY_MAJORV, AWAY_MINORV);
  if (!module_depend(MODULE_NAME, "eggdrop", 106, 0)) {
    module_undepend(MODULE_NAME);
    return "This module requires Eggdrop 1.6.0 or later.";
  }
  add_builtins(H_dcc, away_dcc);
  return NULL;
}
