/*
 * ircbinds.c -- part of botnetop.mod
 *  
 * $Id: ircbinds.c,v 1.8 2001/02/13 18:23:24 sup Exp $
 */
/*
 * Copyright (C) 2000, 2001  Teemu Hjelt <temex@iki.fi>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

static int bnop_modeop(char *nick, char *uhost, char *hand, char *chname, char *mode, char *victim)
{
  int i;
  char s[UHOSTLEN], data[256];
  struct chanset_t *chan = NULL;
  struct userrec *u;
  memberlist *m;

  if ((bop_modeop) && (!egg_strcasecmp(mode, "+o")) && (chan = findchan_by_dname(chname))) {
    if ((egg_strcasecmp(nick, botname)) && (egg_strcasecmp(botname, victim)) && (!isop(botname, chan))) {
      m = ismember(chan, victim);
      egg_snprintf(s, sizeof s, "%s!%s", m->nick, m->userhost);
      u = get_user_by_host(s);
      if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname))) {
        i = nextbot(u->handle);
        if (i >= 0) {
          egg_snprintf(data, sizeof data, "reqops %s", chan->dname);
          botnet_send_zapf(i, botnetnick, u->handle, data);
        }
      }
    }
  }
  return 0;
}

static int bnop_jointmr(char *nick, char *uhost, char *hand, char *chname)
{
  struct chanset_t *chan = NULL;
  struct delay_t *d = NULL;
  struct userrec *u;

  if ((chan = findchan_by_dname(chname)) && (egg_strcasecmp(nick, botname))) {
    u = get_user_by_handle(userlist, hand);
    if ((matchattr(u, "b|-", chan->dname)) && (matchattr(u, "o|o", chan->dname)) && (!matchattr(u, "d|d", chan->dname))) {
      if ((bop_delay) && (!lowbots(chan))) {
        if (!(d = find_delay(chname)))
          d = add_delay(chname, hand);
        d->reqtime = now + (random() % bop_delay) + 5;
        strncpyz(d->bot, hand, sizeof d->bot);
      } else
        bnop_askbot(hand, chan->dname);
    }
  }
  return 0;
}
   
static int bnop_userhost(char *from, char *msg)
{
  char *ptr, *reply, fromnick[NICKLEN], s[UHOSTLEN];
  struct who_t *w = NULL;
  struct chanset_t *chan = NULL;

  ptr = (char *) nmalloc(strlen(msg) + 1);
  if (!ptr)
    return 0;
  reply = ptr;
  strcpy(reply, msg);
  newsplit(&reply);
  reply = newsplit(&reply);
  splitc(fromnick, reply + 1, '=');
  splitc(fromnick, fromnick, '*');
  if ((reply[0]) && (fromnick[0]) && (w = find_who(fromnick)) && (chan = findchan_by_dname(w->chan))) {
    strncpyz(s, strchr("~+-^=", reply[2]) ? reply + 3 : reply + 2, sizeof s);
    if (!egg_strcasecmp(w->uhost, s)) {
      dprintf(DP_SERVER, "INVITE %s %s\n", fromnick, chan->dname);
      if (bop_log >= 1) {
        if (egg_strcasecmp(fromnick, w->bot))
          putlog(LOG_MISC, "*", "botnetop.mod: invited %s (using nick %s) to %s", w->bot, fromnick, chan->dname);
        else
          putlog(LOG_MISC, "*", "botnetop.mod: invited %s to %s", w->bot, chan->dname);
      }
    }
    del_who(w);
  }
  nfree(ptr);
  return 0;
}

static cmd_t botnetop_mode[] =
{
  {"*", "", (Function) bnop_modeop, "bop_modeop"},
  {0, 0, 0, 0}
};

static cmd_t botnetop_join[] =
{
  {"*", "", (Function) bnop_jointmr, "bop_jointmr"},
  {0, 0, 0, 0}
};

static cmd_t botnetop_raw[] =
{
  {"302", "", (Function) bnop_userhost, "bop_userhost"},
  {0, 0, 0, 0}
};
