/*
 * FakeBotnet.mod
 * Version 1.3
 * By Wcc
 * http://www.dawgtcl.com:81/
 * wcc@techmonkeys.org
 *
 * This module provides dcc commands for broadcasting fake
 * botnet messages.
 *
 * Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved.
 *
 */

#define MODULE_NAME "fakebotnet"
#define MAKING_FAKEBOTNET
#define FAKEBOTNET_MAJORV 1
#define FAKEBOTNET_MINORV 3
#include "src/mod/module.h"
#include <stdlib.h>
#undef global

static Function *global = NULL;

char *fakebotnet_start();

static int fakebotnet_expmem()
{
  return 0;
}

static void fakebotnet_report(int idx, int details)
{
  if (details)
    dprintf(idx, "   FakeBotnet.mod Version %d.%d by Wcc is loaded.\n", FAKEBOTNET_MAJORV, FAKEBOTNET_MINORV);
}

static void cmd_flink(struct userrec *u, int idx, char *par)
{
  char *bot, msg[401];

  if (!par[0])
    dprintf(idx, "Usage: flink <bot/fake bot>\n");

  bot = newsplit(&par);
  egg_snprintf(msg, sizeof msg, "Linked to %s.", bot);
  chatout("*** %s\n", msg);
  botnet_send_chat(-1, botnetnick, msg);
}

static void cmd_funlink(struct userrec *u, int idx, char *par)
{
  char *bot, msg[401];

  if (!par[0])
    dprintf(idx, "Usage: funlink <bot/fake bot>\n");
    
  bot = newsplit(&par);
  egg_snprintf(msg, sizeof msg, "Unlinked from: %s (lost 1 bot and 0 users).", bot);
  chatout("*** %s\n", msg);
  botnet_send_chat(-1, botnetnick, msg);
}

static void cmd_fjoined(struct userrec *u, int idx, char *par)
{
  char *user, msg[401];

  if (!par[0])
    dprintf(idx, "Usage: fjoined <user/fake user>\n");
    
  user = newsplit(&par);
  egg_snprintf(msg, sizeof msg, "%s has joined the party line.", user);
  chatout("*** %s\n", msg);
  botnet_send_chat(-1, botnetnick, msg);
}

static void cmd_fleft(struct userrec *u, int idx, char *par)
{
  char *user, msg[401];
    
  if (!par[0])
    dprintf(idx, "Usage: fleft <user/fake user>\n");
    
  user = newsplit(&par);
  egg_snprintf(msg, sizeof msg, "%s has left the party line (lost dcc link).", user);
  chatout("*** %s\n", msg);
  botnet_send_chat(-1, botnetnick, msg);
}

static void cmd_fmsg(struct userrec *u, int idx, char *par)
{
  char msg[401];

  if (!par[0])
    dprintf(idx, "Usage: fmsg <message/fake message>\n");
	
  strncpyz(msg, par, sizeof msg);
  chatout("*** %s\n", msg);
  botnet_send_chat(-1, botnetnick, msg);
}

static cmd_t fakebotnet_dcc[] =
{
  {"flink",     "n",    (Function) cmd_flink,       NULL},
  {"funlink",   "n",    (Function) cmd_funlink,     NULL},
  {"fjoined",   "n",    (Function) cmd_fjoined,     NULL},
  {"fleft",     "n",    (Function) cmd_fleft,       NULL},
  {"fmsg",      "n",    (Function) cmd_fmsg,        NULL},
  {NULL,        NULL,   NULL,                       NULL}
};

static char *fakebotnet_close()
{
  module_undepend(MODULE_NAME);
  rem_builtins(H_dcc, fakebotnet_dcc);
  return NULL;
}

static Function fakebotnet_table[] =
{
  (Function) fakebotnet_start,
  (Function) fakebotnet_close,
  (Function) fakebotnet_expmem,
  (Function) fakebotnet_report,
};

char *fakebotnet_start(Function *global_funcs)
{
  global = global_funcs;
  module_register(MODULE_NAME, fakebotnet_table, FAKEBOTNET_MAJORV, FAKEBOTNET_MINORV);
  if (!module_depend(MODULE_NAME, "eggdrop", 106, 0)) {
    module_undepend(MODULE_NAME);
    return "This module requires Eggdrop 1.6.0 or later.";
  }
  add_builtins(H_dcc, fakebotnet_dcc);
  return NULL;
}
